
-- Boxed-In by mathfacts@cox.net
-- http://members.cox.net/mathfacts/
-- Thanks to the Public Domain for the font file

math.randomseed( math.random(os.time()) )
shot = Sound.load("sounds/shot.wav") ; explode = Sound.load("sounds/explode.wav")
ufoshot = Sound.load("sounds/ufoshot.wav") ;shipexplode = Sound.load("sounds/shipexplode.wav")
warning = Sound.load("sounds/warning.wav"); retro = Sound.load("sounds/retro.wav")
splash = Image.load("sounds/splash.png") ; triangle = Image.load("sounds/triangle.png") ;
startb = Image.load("sounds/startb.png") ;cross = Image.load("sounds/cross.png")
splash2 = Image.load("sounds/splash2.png") ; font_pic = { }
font_pic[1] = Image.load("sounds/font.png"); hifile = "sounds/hiscore.txt"

-- misc variables
green = Color.new(0, 255, 0) ; white = Color.new(255, 255, 255) ;red = Color.new(255, 0, 0)
yellow = Color.new(255, 255, 0);red2 = Color.new(250,0,0) ; ltblue = Color.new (0,255,255)
black = Color.new (0,0,0) ; grey = Color.new(75,75,75)
color = green ;last_time = os.time() ; no_ship = 1 ;skip_timer = 0
max_life = 5 ; life_tot = max_life ;  wave = 1 ;score = 0; dx=0 ; hi_score = 0
-- ship data
cur_angle=180 ; xoff = 276 ; yoff = 120 ; ship_scale = 2.5; vel = 3 ; turn = 10 ; spawn = 0; bsx = { } ; bsy = { }
x = {-3,0,3,0,-3,-2,0,2} ; y = {-5,5,-5,-2,-5,-4,-8,-4} ; xn = {-3,0,3,0,-2,0,2} ; yn = {-5,5,-5,-2,4,-4,-8,-4}
max_points = 5 ;  thrust = 0  ; thrust_dir =0; thrust_chg= 0 ; decay = .008; thrust_step = .23
step_rate = .2 ; step = 0 ; last_angle = 180 ; new_thrust_angle = 180
-- ship bullet data
bullet_xoff = 0 ; bullet_yoff = 0; bullet_vel = 4; bullet_dis = 40 ; bullet_ang = 0;last_shot = os.time();last_ship = os.time()
-- Rock Data
rx = {-2,2,2,-2,-2} ; ry = {2,2,-2,-2,2} ; max_rock_points = 5
rock_xoff = { };rock_yoff = { };rock_angle = { };rock_vel = { };rock_scale = { };
rock_color = { } ; rock_draw = { } ;max_rock_vel = 2 ; adj_rock_vel = 0
-- Ufo Data
ufox = {-2,-1,0,1,2,3,2,-1,-2} ; ufoy = {0,0,-1,-1,0,0,1,1,0} ; ufo_points = 9 ; ufo_vel = {1.25,1.5}; ufo_scale = {6.5,4.5}
ufo_xoff = 60 ; ufo_yoff = math.random(200)+20 ; ufo_dir = 30 ;  ufo = 0 ; ufo_type =1
-- Ufo bullet
ufo_bullet_dis = 0 ; ufo_bullet_vel = {2,4};ufo_bullet_ang = 0 ; ufo_bullet_xoff = 0 ;ufo_bullet_yoff = 0
-- Crash test data
ship_hit = 0; rock_hit = 0; ufo_rock_hit = 0; hits = 0 ; col = 0 ; testx = { }; testy = { } ;
i = 0 ; j = 0  ;npol = 0 ; bxp = 0; byp = 0; xp1 =0 ;yp1 =0 ;cx = { } ; cy = { }
-- boxed in var
colors = {ltblue , white, yellow, red, } ; points = 0 ; ran_out = 0 ; shot_delay = 0 ; mus_time = 0
chosen_color = math.random(4) ; match = 0 ; score_time = os.time() ; start = 1 ; disp_score = 1
-- Timer Stuff
timer = Timer.new() ; timer:start()
timer2 = Timer.new() ; timer2:start()

function fonts(font_num,word,wx,wy)
   for f = 1, string.len(word) do
     row = 0 ; l = string.byte(word,f) - 96 ; if l > 15 then row = 1; l = l-15 ; end
     screen:blit(wx+(f*14),wy,font_pic[font_num], (l*13)-13, row  * 13 +1, 13, 13)
   end
end

function numbers(font_num,word,wx,wy)
   for f = 1, string.len(word) do
     l = string.byte(word,f) - 47
     screen:blit(wx+(f*14),wy,font_pic[font_num], (l*13)-13, 27, 13, 14)
   end
end

function reset_game()
  cur_angle=180; last_angle = 180; new_thrust_angle = 180 ; step =0 ; thrust = 0
  xoff = 276 ; yoff = 120 ; xn = {-3,0,3,0,-3} ; yn = {-5,5,-5,-2,-5}
  score = 0 ; max_rocks = 4  ; life_tot = max_life ; no_ship = 0 ; skip_timer = 0 ; hits = 0
  wave = 1 ; init(); db = 0; dbu = 0 ; ufo = 0 ; ufo_xoff = 60 ; ufo_yoff = math.random(200)+20
  ufo_bullet_dis = 0 ; ran_out = 0
end

function init()
  loadhi() ;   max_rocks = wave +1 ;  make_rocks(1,max_rocks,8)
  cur_angle=180; last_angle = 180; new_thrust_angle = 180 ; step =0 ; thrust = 0 ;  xoff = 276 ; yoff = 120
end

function draw_points(pointsx,pointsy,maxpoints,to_scale,x_offset,y_offset,invx,invy,color,is_ufo)
   for a = 1,maxpoints-1 do
      screen:drawLine((invx*pointsx[a])*to_scale+x_offset, (invy*pointsy[a])*to_scale+y_offset,(invx*pointsx[a+1])*to_scale+x_offset, (invy*pointsy[a+1])*to_scale+y_offset, color)
   end
   if is_ufo == 1 then
      screen:drawLine((invx*pointsx[2])*to_scale+x_offset, (invy*pointsy[2])*to_scale+y_offset,(invx*pointsx[5])*to_scale+x_offset, (invy*pointsy[5])*to_scale+y_offset, color)
   end
end

function disp()
  screen:clear()
  score_box()
  life()
  rotate()
  draw_ship(colors[chosen_color])
  draw_rock()
  make_ufo()
  draw_ufo()
  shoot_ufo()
  if dbu == 1 then check_ship_hit() end
  if dbu == 1 then check_ufo_bullet_rock_hit() end
  if dbu == 1 then draw_ufo_bullet() end
  if db == 1 then draw_bullet() end
  if db == 1 then check_bullet_hit() end
  if no_ship ~= 1 then crash_check() end
  if no_ship ~= 1 then did_crash() end
  if no_ship == 1 then
     fonts(1,"go",7, 180) ;  screen:blit(18,150,triangle)
  end
  numbers(1,tostring(score),-14,1) ;  fonts(1,"wave",-7,35)
  numbers(1,tostring(wave),-7,50) ;  numbers(1,tostring(hi_score),240,8)
  screen.flip()
  screen.waitVblankStart()
end

function score_box()
   screen:fillRect(69,0, 3,272,red)
   sx = 32 ; sy = 100
   for a = 1,max_rock_points -1 do
      for b = 1, 8 do
         screen:drawLine(rx[a]*b+sx, ry[a]*b+sy, rx[a+1]*b+sx, ry[a+1]*b+sy, colors[chosen_color])
      end
   end
   if no_ship == 1 then no_ship = 0; draw_ship(grey) ; no_ship = 1 end
   if ran_out == 1 then
      fonts(1,"you ran out of time",145,80)
   end
   if disp_score == 1 then
       if start ~= 1 then
          fonts(1,"wave clear",195,80)
          fonts(1,"score",203,150) ; screen:print(291,152,"=",yellow)
          numbers(1,tostring(points), 286,148)
       end
   else
      if no_ship ~= 1 then
         fonts(1,"time",-11,170) ; timed = (20+(max_rocks*5))-os.difftime(os.time(), score_time)
         numbers(1,tostring(timed),-11,190)
         if timed < 1 then crashed = 1; ran_out = 1; end
      end
   end
end

function life()
   for l = 1,life_tot-1 do
      draw_points(x,y,5,1.5,(l-1)*15+12,255,1,-1,green,0)
   end
end

function rotate()
  for a = 1,max_points do
    r1 = math.sqrt((x[a]*x[a])+(y[a]*y[a]))
    angle = math.atan2(x[a],y[a])
    angle = angle + math.rad(cur_angle)
    xn[a] = r1 * math.sin(angle)
    yn[a] = r1 * math.cos(angle)
  end
end

function draw_ship(color)
   if no_ship ~= 1 then
      set_thrust()
      thrust = thrust - decay
      if thrust < 0 then thrust = 0 end
      if xoff > 465 then xoff = 465 end
      if xoff < 82 then xoff = 82 end
      if yoff > 260 then yoff = 260 end
      if yoff < 15 then yoff = 15 end
      draw_points(xn,yn,max_points,ship_scale,xoff,yoff,1,1,color,0)
      if boost == 1 then
         retro:play()
         boost = 0; tmp_max = max_points; max_points = 8 ;rotate(); max_points = tmp_max
          for a = 6,8 do
             bsx[a-5] = xn[a]; bsy[a-5] = yn[a] ;
          end
          draw_points(bsx,bsy,3,ship_scale,xoff,yoff,1,1,yellow,0);
      end
   end
end

function draw_rock()
  for r = 1, max_rocks do
   if rock_draw[r] == 1 then
    for a = 1,max_rock_points -1 do
       for b = 1, rock_scale[r] do
          screen:drawLine(rx[a]*b+rock_xoff[r], ry[a]*b+rock_yoff[r], rx[a+1]*b+rock_xoff[r], ry[a+1]*b+rock_yoff[r], colors[rock_color[r]])
       end
    end
    if pass_me ~= 1 then
    rock_xoff[r] = rock_xoff[r] + rock_vel[r]*math.sin(math.rad(rock_angle[r]))
    rock_yoff[r] = rock_yoff[r] + rock_vel[r]*math.cos(math.rad(rock_angle[r]))
       if rock_xoff[r] > 462 then set_rock_angle(r) end
       if rock_xoff[r] < 87 then set_rock_angle(r) end
       if rock_yoff[r] > 252 then set_rock_angle(r) end
       if rock_yoff[r] < 20 then set_rock_angle(r) end
    end
   end
  end
end

function set_rock_angle(ra)
  rd = 0
  if rock_angle[ra] >= 90 then rd = 90 end
  if rock_angle[ra] >= 180 then rd = 180 end
  if rock_angle[ra] >= 270 then rd = 270 end
  rock_angle[ra] = rd + (180 - (rock_angle[ra] - rd))
  if rock_angle[ra] > 360 then rock_angle[ra] = rock_angle[ra] - 360 end
  if rock_angle[ra] < 0 then rock_angle[ra] = rock_angle[ra] + 360 end
end

function make_ufo()
   if wave > 5 and no_ship == 0 then
       if os.difftime (os.time(), last_ship) > 25 then
          ufo = 1; ufo_type = 1  ; warning:play(); last_ship = os.time();
          ufo_xoff = 60 ; ufo_yoff = math.random(200)+20 ; ufo_bullet_dis = 0 ; ufo_bullet_xoff = 0 ;ufo_bullet_yoff = 0
       end
   end
end

function draw_ufo()
   if ufo == 1 then
      draw_points(ufox,ufoy,ufo_points,ufo_scale[ufo_type],ufo_xoff,ufo_yoff,1,1,red,1)
      ufo_xoff = ufo_xoff + ufo_vel[ufo_type]*math.sin(math.rad(ufo_dir))
      ufo_yoff = ufo_yoff + ufo_vel[ufo_type]*math.cos(math.rad(ufo_dir))
      if ufo_yoff > 220 then ufo_dir = 140; end
      if ufo_yoff < 20 then ufo_dir = 30; end
      if ufo_xoff > 480 then
         ufo = 0 ; ufo_xoff = 60 ; ufo_yoff = math.random(200)+20
      end
   end
end

function shoot_ufo()
   if ufo == 1 and dbu ~= 1 then
      if os.difftime (os.time(), last_shot) > 1 then
         dbu = 1; ufo_bullet_xoff = ufo_xoff ; ufo_bullet_yoff = ufo_yoff ; last_shot = os.time()
         tmp = math.random(max_rocks)
         ufo_bullet_ang = (180/math.pi)*math.atan2((rock_xoff[tmp]-ufo_xoff), (rock_yoff[tmp]-ufo_yoff))
      end
   end
end

function draw_ufo_bullet()
   if dbu == 1 then
      screen:fillRect(ufo_bullet_xoff,ufo_bullet_yoff, 3,3,red2 )
      ufo_bullet_dis = ufo_bullet_dis +1
      if ufo_bullet_dis ==1 then
         if ufo_type == 1 then ufoshot:play() else ufoshot2:play(); end
      end
      ufo_bullet_xoff = ufo_bullet_xoff + ufo_bullet_vel[ufo_type]*math.sin(math.rad(ufo_bullet_ang))
      ufo_bullet_yoff = ufo_bullet_yoff + ufo_bullet_vel[ufo_type]*math.cos(math.rad(ufo_bullet_ang))
      if ufo_bullet_xoff < 75 or ufo_bullet_yoff < 0 or ufo_bullet_xoff > 480 or ufo_bullet_yoff > 272 then dbu = 0; ufo_bullet_dis =0 ; end
   end
end

function draw_bullet()
  if db == 1 then
      screen:fillRect(bullet_xoff,bullet_yoff, 2,2,yellow )
      bullet_xoff = bullet_xoff + bullet_vel*math.sin(math.rad(bullet_ang))
      bullet_yoff = bullet_yoff + bullet_vel*math.cos(math.rad(bullet_ang))
      if bullet_xoff < 75 then db = 0; hit_it = 0 ;  end
      if bullet_yoff < 0 then db = 0; hit_it = 0 ;  end
      if bullet_xoff > 480 then db = 0; hit_it = 0 ;  end
      if bullet_yoff > 272 then db = 0; hit_it = 0 ;  end
  end
end

function make_rocks(start,qty,size)
  math.randomseed( math.random(os.time()) )
  adj_rock_vel = max_rock_vel
  if wave > 3 then size = 7 ; end
  if wave > 6 then size = 6 ; end
  if wave > 9 then size = 5 ; end
  if wave > 12 then size = 4 ; end
  if wave > 15 then size = 3 ; end
  for a = start,qty do
    rock_xoff[a] = math.random(373) + 87
    rock_yoff[a] = math.random(230) + 20
    rock_angle[a]= (math.random(60)+15)+ (90*(math.random(4)-1))
    rock_vel[a] = math.random(wave*20)/100+.5
    if wave > 4 then adj_rock_vel = max_rock_vel - .5 end
    if wave > 6 then adj_rock_vel = max_rock_vel - .65 end
    if wave > 9 then adj_rock_vel = max_rock_vel - .75 end
    if wave > 12 then adj_rock_vel = max_rock_vel - 1 end
    if wave > 16 then adj_rock_vel = max_rock_vel - 1.25 end
    if wave > 20 then adj_rock_vel = max_rock_vel - 1.5 end
    if rock_vel[a] > adj_rock_vel then rock_vel[a] = adj_rock_vel ; end
    rock_scale[a] = size
    rock_color[a] = math.random(4)
    while rock_color[a] == chosen_color do
       rock_color[a] = math.random(4)
    end
    rock_draw[a] = 1
  end
end

function analog()
  dx = pad:analogX()
  if dx > 32 then bt = 4 ; end
  if dx < -32 then  bt = 3 ; end
end

function did_crash()
  if crashed == 1 then
    shipexplode:play()
    crashed = 0 ; draw_crash() ; life_tot = life_tot - 1
    if life_tot == 0 then game_over() end
    cur_angle=180; last_angle = 180; new_thrust_angle = 180 ; step =0 ; thrust = 0
    xoff = 276 ; yoff = 120; thrust = 0 ;  no_ship = 1
  end
end

function draw_crash()
  cx[1]=xn[1];cx[2]=xn[2];cx[3]=xn[2];cx[4]=xn[3];cx[5]=xn[3];cx[6]=xn[4];cx[7]=xn[4];cx[8]=xn[1]
  cy[1]=yn[1];cy[2]=yn[2];cy[3]=yn[2];cy[4]=yn[3];cy[5]=yn[3];cy[6]=yn[4];cy[7]=yn[4];cy[8]=yn[1]
  xd = {-1.2, -.9, .7,1.1,.6,.8, -.6,-.9}; yd = {1,1.4,.6,.9,-.8,-.5,-.8,-.6}
  for c = 1, 30 do
    screen:clear()
    for a = 1, 8 do
      cx[a] = cx[a] + xd[a]; cy[a] = cy[a] +yd[a]
    end
    screen:drawLine(cx[1]*ship_scale+xoff, cy[1]*ship_scale+yoff, cx[2]*ship_scale+xoff, cy[2]*ship_scale+yoff, color)
    screen:drawLine(cx[3]*ship_scale+xoff, cy[3]*ship_scale+yoff, cx[4]*ship_scale+xoff, cy[4]*ship_scale+yoff, color)
    screen:drawLine(cx[5]*ship_scale+xoff, cy[5]*ship_scale+yoff, cx[6]*ship_scale+xoff, cy[6]*ship_scale+yoff, color)
    screen:drawLine(cx[7]*ship_scale+xoff, cy[7]*ship_scale+yoff, cx[8]*ship_scale+xoff, cy[8]*ship_scale+yoff, color)
    draw_rock()
    screen.waitVblankStart()
    screen.flip()
  end
end

function game_over()
   if score > hi_score then hi_score = score ; savehi(); end
   screen:clear(); screen.flip() ;  screen.waitVblankStart()
   pass_me = 1
   reset_block2()
   screen:clear()
   for a = 1,80 do
      rnd = math.random(80)
      while rock_draw[rnd] == 1 do
         rnd = math.random(80)
      end
      rock_draw[rnd] = 1
      draw_rock()
      fonts(1,"score",1, 60); fonts(1,"hi score",1, 140);
      numbers(1,tostring(score),10,80) ;numbers(1,tostring(hi_score),10,160)
      screen.flip() ;  screen.waitVblankStart()
   end
   while not Controls.read():start() do
      screen:clear(); draw_rock()
      fonts(1,"score",1, 60); fonts(1,"hi score",1, 140);
      numbers(1,tostring(score),10,80) ;numbers(1,tostring(hi_score),10,160)
      screen:blit(30,220,startb)
      screen:print(210,253,"mathfacts@cox.net",yellow)
      screen.flip() ;  screen.waitVblankStart()
   end
   max_rocks = 2 ; pass_me = 0; ufo = 0 ; dbu = 0  ;  reset_game()
   init()
end

function get_key()
  bt = 0
  while bt == 0 do
   if skip_timer ~= 1 then disp() end
       pad = Controls.read()
       analog()
       if pad ~= oldPad then
         if pad:up() then bt = 1
            elseif pad:down() then bt = 2
            elseif pad:left() then bt = 3
            elseif pad:right() then bt = 4
            elseif pad:triangle() then bt = 5
            elseif pad:circle() then bt = 6
            elseif pad:cross() then bt = 7
            elseif pad:square() then bt = 8
            elseif pad:l() then bt = 9
            elseif pad:r() then bt = 10
            elseif pad:select() then bt = 11
            elseif pad:start() then bt = 12
         end
         --oldPad = pad
       end
     if skip_timer ~= 1 then disp() end
  end
end

function set_thrust()
   thrust = thrust + thrust_chg
   xdelta = 0; ydelta = 0
   if new_thrust_angle ~= last_angle then
      xnew = thrust_chg*math.sin(math.rad(new_thrust_angle))
      ynew = thrust_chg*math.cos(math.rad(new_thrust_angle))
      xold = (thrust-thrust_chg)*math.sin(math.rad(last_angle))
      yold = (thrust-thrust_chg)*math.cos(math.rad(last_angle))
      xdelta = xnew + xold ; ydelta = ynew + yold
      thrust = math.sqrt((xdelta*xdelta)+(ydelta*ydelta))
      last_angle = math.deg(math.atan2(xdelta,ydelta))
    else
       xdelta = thrust*math.sin(math.rad(last_angle))
       ydelta = thrust*math.cos(math.rad(last_angle))
    end
    xoff = xoff + xdelta ; yoff = yoff + ydelta
    thrust_chg = 0
    if thrust > vel then thrust = vel; end
    if thrust < 0 then thrust = 0; end
end

function check_bullet_hit()
  bxp = bullet_xoff ;  byp = bullet_yoff ; rock_hit = 0
    for r = 1, max_rocks do
      if rock_draw[r] ~=0 then
         if rock_hit == 0 then
            for t = 1, max_rock_points do
              testx[t] = (rock_scale[r] * rx[t]) + rock_xoff[r]
              testy[t] = (rock_scale[r] * ry[t]) + rock_yoff[r]
            end
            check (max_rock_points, testx, testy, bxp, byp)
            if col == 1 then rock_hit = r; end
         end
      end
   end
   if rock_hit ~= 0 then
      hit_rock()
   else
      if ufo ~= 0 then
        bxp = bullet_xoff ;  byp = bullet_yoff ; ufo_hit = 0
           for t = 1, ufo_points do
              testx[t] = (ufo_scale[ufo] * ufox[t]) + ufo_xoff
              testy[t] = (ufo_scale[ufo] * ufoy[t]) + ufo_yoff
           end
           check (ufo_points, testx, testy, bxp, byp)
              if col == 1 then explode:play(); ufo_hit = 1; score = score + ufo * 25; ufo = 0 ;db = 0; end
      end
   end
end

function check_ship_hit()
   if no_ship ~= 1 then
     bxp = ufo_bullet_xoff ;  byp = ufo_bullet_yoff ; crashed = 0
        for t = 1, max_points do
           testx[t] = (ship_scale * xn[t]) + xoff
           testy[t] = (ship_scale * yn[t]) + yoff
        end
        check (max_points, testx, testy, bxp, byp)
           if col == 1 then  db = 0; crashed=1 ; dbu = 0; end
   end
end

function check_ufo_bullet_rock_hit()
      bxp = ufo_bullet_xoff ;  byp = ufo_bullet_yoff ; rock_hit = 0
      for r = 1, max_rocks do
         if rock_draw[r] ~=0 then
            if rock_hit == 0 then
               for t = 1, max_rock_points do
                 testx[t] = (rock_scale[r] * rx[t]) + rock_xoff[r]
                 testy[t] = (rock_scale[r] * ry[t]) + rock_yoff[r]
               end
               check (max_rock_points, testx, testy, bxp, byp)
               if col == 1 then rock_hit = r; ufo_bullet_dis = 0; end
            end
         end
      end
      if rock_hit ~= 0 then ufo_rock_hit = 1; hit_rock() ; end
end

function hit_rock()
  if rock_hit ~= 0 then
     explode:play(); hits = hits +1  ; hit_it = 0
     if ufo_rock_hit == 1 then dbu = 0 else db = 0 end
     rock_color[rock_hit] = rock_color[rock_hit] +1
     if rock_color[rock_hit] > 4 then rock_color[rock_hit] = 1 end
  end
  if pass_me ~= 1 then
     check_all_same()
  end
  rock_hit = 0 ; ufo_rock_hit = 0
end

function check_all_same()
  match = 1
  for a = 1, max_rocks do
    if rock_color[a] ~= chosen_color then match = 0 end
  end

  if match == 1 then
     last_chosen_color = chosen_color
     while chosen_color == last_chosen_color do
        chosen_color = math.random(4)
     end
     no_ship = 1
     points = ((20+(max_rocks*5))-os.difftime(os.time(), score_time))*wave
     score = score + points ; disp_score = 1
     wave = wave + 1
     init()
  end
end

function crash_check()
 if ship ~= 1 then
   ship_hit = 0
   for b = 1,max_points do
      bxp = (xn[b]*ship_scale)+xoff ;  byp = (yn[b]*ship_scale)+yoff
      for r = 1, max_rocks do
         if rock_draw[r] ~= 0 and rock_color[r] ~= chosen_color then
            if ship_hit == 0 then
               for t = 1, max_rock_points do
                 testx[t] = (rock_scale[r] * rx[t]) + rock_xoff[r]
                 testy[t] = (rock_scale[r] * ry[t]) + rock_yoff[r]
               end
               check (max_rock_points, testx, testy, bxp, byp)
               if col == 1 then ship_hit = r; crashed = 1; end
            end
         end
      end
   end
   if ufo~= 0 and ship_hit == 0 then
      ufo_hit_ship = 0
      for b = 1,max_points do
         bxp = (xn[b]*ship_scale)+xoff ;  byp = (yn[b]*ship_scale)+yoff
         if ufo_hit_ship == 0 then
            for t = 1, ufo_points do
               testx[t] = (ufo_scale[ufo] * ufox[t]) + ufo_xoff
               testy[t] = (ufo_scale[ufo] * ufoy[t]) + ufo_yoff
            end
            check (ufo_points, testx, testy, bxp, byp)
            if col == 1 then crashed = 1; ufo = 0; ufo_hit_ship = 1; end
         end
      end
   end
 end
end


function check(npol, xp, yp, xp1, yp1)
   col = 0 ;  j = npol
   for i = 1,npol do
      if ((((yp[i] <= yp1) and (yp1 <yp[j])) or ((yp[j] <= yp1) and (yp1 < yp[i]))) and (xp1<((((xp[j]-xp[i])*(yp1-yp[i]))/(yp[j]-yp[i]))+xp[i]))) then
        if col == 0 then col = 1 else col = 0  end
      end
      j = i
   end
end

function play()
bt=0
   while bt == 0 do
      get_key()
   end
   if bt == 1 then
     if no_ship ~= 1 then
        thrust_chg =  thrust_step ; new_thrust_angle = cur_angle ; boost = 1 ; step = 0
     end
   end
   if bt == 8 then
      if no_ship ~= 1 then
         thrust_chg =  thrust_step ; new_thrust_angle = cur_angle ; boost = 1 ; step = 0
      end
   end
   if bt == 4 then
     if no_ship ~= 1 then
        cur_angle = cur_angle - turn
     end
   end
   if bt == 3 then
      if no_ship ~= 1 then
         cur_angle = cur_angle + turn
      end
   end
   if bt == 5 then
      if no_ship ~= 0 then
         no_ship = 0; score_time = os.time() ; disp_score = 0 ; ran_out = 0 ; start = 0
         math.randomseed( math.random(os.time()) ) ; last_ship = os.time()
      end
   end
   if bt == 6 then
      if no_ship ~= 1 then
         if timer2:time()  > 200 then
            xoff = math.random(370)+90 ; yoff = math.random(232)+20 ; thrust = 0
            timer2:reset() ; timer2:start()
         end
      end
   end
   if bt == 7 then
      if no_ship ~= 1 then
         if db ~= 1 then
            if timer:time()  > 150 then
               shot:play()
               bullet_xoff = xn[2] + xoff ; bullet_yoff = yn[2] + yoff ; db = 1 ; bullet_dis = 1 ; bullet_ang = cur_angle
               bullet_xoff = bullet_xoff + 7*math.sin(math.rad(bullet_ang))
               bullet_yoff = bullet_yoff + 7*math.cos(math.rad(bullet_ang))
               timer:reset() ; timer:start()
            end
         end
      end
   end
   if cur_angle > 360 then cur_angle = cur_angle - 360 end
   if cur_angle < 0 then cur_angle = cur_angle + 360 end
   bt = 0
end

function savehi()
  file = io.open(hifile, "w")
  if file then file:write(score .. "\n") ; file:close() ; end
end

function loadhi()
  file = io.open(hifile, "r")
  if file then hi_score = file:read("*n") ;   file:close(); end
end

function intro()
   screen:clear(); screen.flip() ;  screen.waitVblankStart()
   screen:blit(0,0,splash)
   screen.flip() ;  screen.waitVblankStart()
   while os.difftime(os.time(), last_time) < 5 do
   end
   screen:clear(); screen.flip() ;  screen.waitVblankStart()
   pass_me = 1
   reset_block()
   screen:clear()
   for a = 1,68 do
      rnd = math.random(68)
      while rock_draw[rnd] == 1 do
         rnd = math.random(68)
      end
      rock_draw[rnd] = 1
      draw_rock()
      screen.flip() ;  screen.waitVblankStart()
   end
   while not Controls.read():start() do
      screen:clear(); draw_rock()
      screen:blit(1,190,cross) ; screen:blit(310,190,startb)
      fonts(1,"hold for directions",20,200); fonts(1,"to play",360,200)
      screen:print(180,253,"mathfacts@cox.net",yellow)
      ufo_vel[1] = 3 ; ufo_bullet_vel[1] = 4
      ufo = 1 ; draw_ufo() ; shoot_ufo();
      if dbu == 1 then
        draw_ufo_bullet(); check_ufo_bullet_rock_hit()
      end
      if Controls.read():cross() then
         screen:blit(0,0,splash2)
      end
      screen.flip() ;  screen.waitVblankStart()
   end
   max_rocks = 2 ; pass_me = 0; ufo = 0 ; dbu = 0 ; ufo_vel[1] = 1.25 ; ufo_bullet_vel[1] = 2
end

function reset_block()
   max_rocks = 68
   rowx = {1,2,6,9,11,13,14,15,17,18,1,3,5,7,9,11,13,17,19,1,2,5,7,10,13,14,17,19,
   1,3,5,7,9,11,13,17,19,1,2,6,9,11,13,14,15,17,18,22,23,24,26,28,23,26,27,28,
   23,26,27,28,23,26,28, 22,23,24,26,28}
   rowy = {1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,3,3,3,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,
   5,5,5,5,5,5,5,5,5,5,2,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,6,6,6,6,6}
   for a = 1, max_rocks do
       rock_xoff[a] = rowx[a] * 16 ; rock_yoff[a] = rowy[a] * 20 + 30
       rock_angle[a]= 0 ; rock_vel[a] = 0 ; rock_scale[a] = 4
       rock_color[a] = math.random(4) ; rock_draw[a] = 0
   end
end

function reset_block2()
   max_rocks = 80
   rowx = {1,2,3,6,9,11,13,14,15,2,5,7,9,10,11,13,14,1,5,7,9,10,11,13,1,3,5,7,9,13,15,
   1,2,3,5,6,7,9,11,13,14,1,3,5,7,9,10,13,14,1,3,5,7,9,11,13,1,3,5,7,9,13,15,1,2,3,5,7,9,
   11,13,14,15,2,6,9,10,11,13,15}
   rowy = {1,1,1,1,1,1,1,1,1,7,7,7,7,7,7,7,7,2,2,2,2,2,2,2,8,8,8,8,8,8,8,3,3,3,3,3,3,3,3,3,3,
   9,9,9,9,9,9,9,9,4,4,4,4,4,4,4,10,10,10,10,10,10,10,5,5,5,5,5,5,5,5,5,5,11,11,11,11,11,11,11}
   for a = 1, max_rocks do
       rock_xoff[a] = rowx[a] * 16 + 150 ; rock_yoff[a] = rowy[a] * 20 + 10
       rock_angle[a]= 0 ; rock_vel[a] = 0 ;  rock_scale[a] = 4
       rock_color[a] = math.random(4) ;  rock_draw[a] = 0
   end
end

intro()
init()
while true do
 play()
end
